#!/bin/sh
#	This is a shell archive.
#	Run the file through sh to extract its contents.
# shar:	Shell Archiver
#	Run the following text with /bin/sh to create:
#	defining-forms.s
#	type-constructors.s
#	globals.s
# This archive created: Tue Nov  7 11:24:43 1989
echo shar: extracting defining-forms.s '(2415 characters)'
sed 's/^X//' << \SHAR_EOF > defining-forms.s
X;;; defining-forms.s
X
X;;; basic macros for typechecking system:  
X;;; define-unchecked, define-checked, define-type-abbrev,
X;;; declare-unchecked
X
X;;; rewritten to use extend-syntax Thu Nov 10 14:56:38 1988
X;;; Also define-checked produces name and type as its output.
X
X;;; extracted from old distribution/check1.s (was not on margaret's
X;;; version).  Sun Nov  6 22:49:07 1988
X
X(extend-syntax (define-unchecked)
X  [(define-unchecked name type value)
X   (with ([type-scheme (external-type->type-scheme 'type)])
X     (begin
X       (change-global-prefix! 'name 'type-scheme)
X;   (add-undefined-types-to-badlist ',type ',generics)
X       (set! name value)
X       (list 'name ': 'type)))])
X
X(extend-syntax (declare-unchecked)
X  [(declare-unchecked name generics type)
X   (begin
X     (change-global-prefix! 'name (make-type-scheme 'generics 'type))
X     ;(add-undefined-types-to-badlist ',(cadddr l) ',(caddr l))
X     'name)])
X
X
X
X(extend-syntax (define-type-abbrev)
X  [(define-type-abbrev name type-exp)
X   (begin
X     (extend-global-type-env! 'name 'type-exp)
X;    (bind-typevar ',name ',type-exp ',l global-type-env)
X;    (check-type-abbrev ',name ',type-exp)
X     'name)])
X
X
X(extend-syntax (define-checked)
X  [(define-checked name type value)
X   (with ((type-scheme (external-type->type-scheme 'type)))
X     (with ((ans (check-define-checked 'name 'type-scheme 'value)))
X       (if 'ans
X	 (begin
X	   (change-global-prefix! 'name 'type-scheme)
X	   ;;(add-undefined-types-to-badlist....)
X	   (set! name value)
X	   (printf "~s : ~s~%" 'name 'type))
X	 (reset))))])
X
X;;; the following code is OK, except it needs to check the type-scheme
X;;; for unbound type variables not included in the list of generics.
X
X(define check-define-checked
X  (lambda (name type-scheme value)
X    (call/cc
X      (lambda (return)
X	(let ((generics (type-scheme->generics type-scheme))
X	      (type     (type-scheme->type type-scheme))
X	      (dummy    (gen-fcn-sym)))
X	  ;;(add-undefined-types-to-badlist type generics)
X	  (checker
X	    (ext-prefix
X	      (list name dummy)
X	      (list 
X		type-scheme
X		(make-type-scheme
X		  '()
X		  (make-functional-type
X		    (list (subst-consts-for-generics type-scheme))
X		    (gen-type-var))))
X	      empty-prefix)
X	    (make-application dummy (list value))
X	    empty-type-env
X	    (lambda (msg)
X	      (printf "define-checked: error in ~s:~%" name)
X	      (pretty-print msg)
X	      (return '()))))))))
X
X
SHAR_EOF
if test 2415 -ne "`wc -c defining-forms.s`"
then
echo shar: error transmitting defining-forms.s '(should have been 2415 characters)'
fi
echo shar: extracting type-constructors.s '(5357 characters)'
sed 's/^X//' << \SHAR_EOF > type-constructors.s
X;;; type-constructors.s
X
X;;; define-record-type and define-type-constructor
X
X; The following code defines a macro for defining record types with variant
X; records in type-checked code, much like the types in Hope or Standard ML.
X; The record types are in fact type-constructors, so one can define
X; parameterized types like (stack x).  One declares a global constructor
X; name for each variant, along with the types of the components.
X; These are exported, along with a case function (eg stack-case),
X; which decomposes any instance of the record and sends 
X; the component to the appropriate function.  Examples are below.
X
X
X;;; this code is OK, with a couple of exceptions:
X
X;;; 1.  The construction of the types should be done with abstract
X;;; rather than concrete syntax.
X
X;;; 2.  What should be exported is a decomposition MACRO, like
X;;; record-case, rather than a function.
X
X;;; ****************************************************************
X
X(extend-syntax (define-record-type)
X   [(define-record-type
X       (type-name type-var ...)
X       [constructor-name  component-types]
X       ...)
X    (with ([name-for-case-function
X	     (string->symbol
X	       (string-append
X		 (symbol->string 'type-name)
X		 "-case"))])
X      (list
X	(define-unchecked constructor-name
X	  (generic (type-var ...)
X	    (-> (seq . component-types) (type-name type-var ...)))
X	  (lambda x (cons 'constructor-name x)))
X	...
X	(define-unchecked name-for-case-function
X	  (generic (target-type type-var ...)
X	    (-> (seq (type-name type-var ...)
X		     (-> (seq . component-types) target-type)
X		     ...)
X		target-type))
X	  (lambda (x . fnlist)
X	    (let loop
X	      ([tagnames '(constructor-name ...)]
X	       [functions fnlist])
X	      (cond
X		[(null? tagnames) 
X		 (report-error (list "Bad data to struct selector" x))]
X		[(eq? (car x) (car tagnames))
X		 (apply (car functions) (cdr x))]
X		[t (loop (cdr tagnames) (cdr functions))]))))))])
X
X
X
X; some simple-minded examples:
X
X'(define-record-type (stack x)	; how could we not have a stack example?
X   (empty-stack ())
X   (push-stack (x (stack x))))
X
X;; exports: empty-stack () -> (stack x), push-stack x * (stack x) ->
X;; stack x, and stack-case: (stack x) * (()->y) * (x*(stack x)->y) -> y.
X
X; one could use this facility to build lists, pairs, and unions, albeit
X; somewhat less efficiently than the existing facilities:
X
X'(define-record-type (zlist x)
X   (znil ())
X   (zcons (x (zlist x))))
X
X'(define-record-type (zpair x y)
X   (zpair (x y)))
X
X; a simple-minded test tag:
X
X'(define-checked test-zlist
X   (-> (seq) (list int))
X   (lambda ()
X      (let loop ([x (zcons 1 (zcons 2 (zcons 3 (znil))))])
X	   (zlist-case x
X	      (lambda () nil)
X	      (lambda (a d) (cons a (loop d)))))))
X
X;;; ****************************************************************
X
X;;; define-type-constructor
X
X; type-definition facility.  The functions are defined globally, but the
X; representation (rep) is hidden.  
X
X; the syntax has changed slightly from old versions:  it declares the
X; global generics the same way as define-record-type, and individual
X; functions must have all their generics declared locally with
X; (generic (x y) ...)
X
X(extend-syntax (define-type-constructor)
X  [(define-type-constructor
X     (name type-var ...)
X     rep-type
X     (fn-name fn-type value) ...)
X   (with ([(type-scheme ...)
X	   (map external-type->type-scheme  '(fn-type ...))]
X	  [group-prefix (make-group-prefix 'name '(type-var ...)
X			  'rep-type '(fn-name ...) '(fn-type ...))])
X     (with
X       ([(ans ...)
X	 (map
X	   (lambda (fn-name fn-type value)
X	     (check-operation fn-name fn-type 'group-prefix value))
X	   '(fn-name ...) '(fn-type ...) '(value ...))])
X       (list
X	 (if 'ans
X	   (begin
X	     (change-global-prefix! 'fn-name 'type-scheme)
X	     (set! fn-name
X	       (let ((dec (lambda (x) x))
X		     (enc (lambda (x) x)))
X		 value))
X	     (list 'fn-name 'fn-type))
X	   (list 'fn-name ': 'type-error))
X	 ...)))])
X
X(define make-group-prefix
X  (lambda (name type-vars rep-type fn-names fn-types)
X    (let
X      ([type (make-type name type-vars)])
X      (ext-prefix
X	   (list 'dec 'enc)
X	   (list
X	     (make-type-scheme type-vars
X	       (make-functional-type (list type) rep-type))
X	     (make-type-scheme type-vars
X	       (make-functional-type (list rep-type) type)))
X	   (ext-prefix
X	     fn-names
X	     (map external-type->type-scheme fn-types)
X	     empty-prefix)))))
X
X(define check-operation
X  (lambda (fn-name fn-type group-prefix value)
X    (call/cc
X      (lambda (return)
X	(let* ((dummy-name (gen-fcn-sym))
X	       (type-scheme (external-type->type-scheme fn-type))
X	       (generics (type-scheme->generics type-scheme))
X	       (type     (type-scheme->type type-scheme)))
X	  ;;(add-undefined-types-to-badlist external-type generics)
X	  ;;(printf "check-operation: fn-name = ~s fn-type = ~s ~%"
X	  ;;fn-name fn-type)
X	  ;;(printf "type-scheme = ~s~%group-prefix =~%" type-scheme)
X	  ;;(pretty-print group-prefix)
X	  (checker
X	    (ext-prefix 
X	      (list dummy-name)
X	      (list
X		(make-type-scheme
X		  '()
X		  (make-functional-type
X		    (list (subst-consts-for-generics type-scheme))
X		    (gen-type-var))))
X	      group-prefix)
X	    (make-application dummy-name (list value))
X	    empty-type-env
X	    (lambda (msg)
X		(printf "define-type-constructor: error in ~s:~%" fn-name)
X		(pretty-print msg)
X		(return '()))))))))
X
X
X
X
X
SHAR_EOF
if test 5357 -ne "`wc -c type-constructors.s`"
then
echo shar: error transmitting type-constructors.s '(should have been 5357 characters)'
fi
echo shar: extracting globals.s '(8797 characters)'
sed 's/^X//' << \SHAR_EOF > globals.s
X;;; globals.s declaration of types for Scheme constants
X
X;;; slightly hacked for Chez Scheme, etc. Wed Nov  9 11:23:41 1988
X
X
X(define pair cons)
X(define lson car)
X(define rson cdr)
X(define true #t)
X(define false #f)
X
X(define any '*any*)
X(define print (lambda (x) (printf "~s" x)))
X(define newline (lambda () (printf "~%")))
X(define unchecked (lambda (x) x))
X
X(extend-syntax (fix)
X  ((fix name exp) (rec name exp)))
X
X(extend-syntax (and)
X  ((and) true)
X  ((and x y ...)
X   (if x (and y ...) false)))
X
X(extend-syntax (or)
X  ((or) false)
X  ((or x y ...)
X   (if x true (or y ...))))
X
X(extend-syntax (letrec)
X  [(letrec ((x v) ...) e1 e2 ...)
X   (let ((x any) ...)
X     (set! x v) ...
X     e1 e2 ...)])
X
X(define-type-abbrev bool (bool))
X(define-type-abbrev int (int))
X(define-type-abbrev symbol (symbol))
X(define-type-abbrev literal (symbol))	; for compatibility
X(define-type-abbrev string (string))
X(define-type-abbrev triv (triv))	; (triv) defined below
X(define-type-abbrev char (char))	; no use yet, should revise
X					; this file to use it.
X
X(declare-unchecked * () (-> (seq int int) int))
X(declare-unchecked + () (-> (seq int int) int))
X(declare-unchecked - () (-> (seq int int) int))
X(declare-unchecked / () (-> (seq int int) int))
X(declare-unchecked 1+ () (-> (seq int) int))
X(declare-unchecked 1- () (-> (seq int) int))
X(declare-unchecked < () (-> (seq int int) bool))
X(declare-unchecked <= () (-> (seq int int) bool))
X(declare-unchecked = () (-> (seq int int) bool))
X(declare-unchecked > () (-> (seq int int) bool))
X(declare-unchecked >= () (-> (seq int int) bool))
X(declare-unchecked abs () (-> (seq int) int))
X(declare-unchecked any (x) x)		; initialization eg '*
X(declare-unchecked append (x) (-> (seq (list x) (list x)) (list x)))
X(declare-unchecked append! (x) (-> (seq (list x) (list x)) (list x)))
X(declare-unchecked atom? (x) (-> (seq x) bool))
X(declare-unchecked cadddr (y) (-> (seq (list y)) y))
X(declare-unchecked caddr (y) (-> (seq (list y)) y))
X(declare-unchecked cadr (y) (-> (seq (list y)) y))
X(declare-unchecked car (y) (-> (seq (list y)) y))
X(declare-unchecked cdddr (y) (-> (seq (list y)) (list y)))
X(declare-unchecked cddr (y) (-> (seq (list y)) (list y)))
X(declare-unchecked cdr (y) (-> (seq (list y)) (list y)))
X(declare-unchecked cons (x) (-> (seq x (list x)) (list x)))
X(declare-unchecked display (x) (-> (seq x) bool))
X(declare-unchecked eq? (x) (-> (seq x x) bool))
X(declare-unchecked equal? (x) (-> (seq x x) bool))
X(declare-unchecked eqv? (x) (-> (seq x x) bool))
X(declare-unchecked error (x) (-> (seq string . x) y))
X(declare-unchecked exit (y) (-> (seq) y))
X(declare-unchecked false () bool)
X(declare-unchecked file-exists? () (-> (seq string) bool))
X(declare-unchecked gensym (x) (-> (seq x) literal))
X(declare-unchecked if (z) (-> (seq bool z z) z))
X(declare-unchecked last-pair (x) (-> (seq (list x)) (list x)))
X(declare-unchecked length (x) (-> (seq (list x)) int))
X(declare-unchecked list-ref (x) (-> (seq (list x) int) x))
X(declare-unchecked list-tail (x) (-> (seq (list x) int) (list x)))
X(declare-unchecked lson (x y) (-> (seq (pair x y)) x))
X(declare-unchecked map (x y z) (-> (seq (-> (seq x) y) (list x)) (list z)))
X(declare-unchecked max () (-> (seq int int) int))
X(declare-unchecked member (x) (-> (seq x (list x)) bool))
X(declare-unchecked memq () (-> (seq literal (list literal)) bool))
X(declare-unchecked memv (x) (-> (seq x (list x)) bool))
X(declare-unchecked min () (-> (seq int int) int))
X(declare-unchecked minus () (-> (seq int) int))
X(declare-unchecked modulo () (-> (seq int int) int))
X(declare-unchecked negative? () (-> (seq int) bool))
X(declare-unchecked newline (x) (-> (seq) bool))
X(declare-unchecked nil (z) (list z))
X(declare-unchecked not () (-> (seq bool) bool))
X(declare-unchecked null? (z) (-> (seq (list z)) bool))
X(declare-unchecked number? (x) (-> (seq x) bool))
X(declare-unchecked pair (x y) (-> (seq x y) (pair x y)))
X(declare-unchecked pair? (x) (-> (seq x) bool))
X(declare-unchecked positive? () (-> (seq int) bool))
X(declare-unchecked pretty-print (x) (-> (seq x) bool))
X(declare-unchecked print (x) (-> (seq x) bool))
X(declare-unchecked printf (x) (-> (seq string . x) bool))
X(declare-unchecked print-length (x) (-> (seq x) int))
X(declare-unchecked random () (-> (seq int) int))
X(declare-unchecked read-char () (-> (seq) literal))
X(declare-unchecked remainder () (-> (seq int int) int))
X(declare-unchecked reset (y) (-> (seq) y))
X(declare-unchecked reverse (x) (-> (seq (list x)) (list x)))
X(declare-unchecked reverse! (x) (-> (seq (list x)) (list x)))
X(declare-unchecked rson (x y) (-> (seq (pair x y)) y))
X(declare-unchecked set! (x) (-> (seq x x) x))
X(declare-unchecked set-car! (x y) (-> (seq (pair x y) x) (pair x y)))
X(declare-unchecked set-cdr! (x y) (-> (seq (pair x y) y) (pair x y)))
X(declare-unchecked string<? () (-> (seq string string) bool))
X(declare-unchecked string? (x) (-> (seq x) bool))
X(declare-unchecked subst (x) (-> (seq x x (list x)) (list x)))
X(declare-unchecked substring () (-> (seq string int int) string))
X(declare-unchecked symbol? (x) (-> (seq x) bool))
X(declare-unchecked syntactic-extension? () (-> (seq literal) bool))
X(declare-unchecked true () bool)
X(declare-unchecked zero? () (-> (seq int) bool))
X
X
X;;; definitions not in Chez Scheme
X;(declare-unchecked #!if (z) (-> (seq bool z z) z))
X;(declare-unchecked <0 () (-> (seq int) bool))
X;(declare-unchecked <=? () (-> (seq int int) bool))
X;(declare-unchecked <? () (-> (seq int int) bool))
X;(declare-unchecked =0 () (-> (seq int) bool))
X;(declare-unchecked =? () (-> (seq int int) bool))
X;(declare-unchecked >0 () (-> (seq int) bool))
X;(declare-unchecked >=? () (-> (seq int int) bool))
X;(declare-unchecked >? () (-> (seq int int) bool))
X;(declare-unchecked alpha< () (-> (seq literal literal) bool))
X;(declare-unchecked ascii->symbol () (-> (seq int) literal))
X;(declare-unchecked concat () (-> (seq string string) string))
X;(declare-unchecked copy (x) (-> (seq x) x))
X;(declare-unchecked current-column () (-> (seq) int))
X;(declare-unchecked delete! (x) (-> (seq x (list x)) (list x)))
X;(declare-unchecked delq! (x) (-> (seq x (list x)) (list x)))
X;(declare-unchecked display& (x) (-> (seq x) bool))
X;(declare-unchecked error (x y) (-> (seq . x) y))
X;(declare-unchecked explode () (-> (seq literal) (list literal)))
X;(declare-unchecked fix? (x) (-> (seq x) bool))
X;(declare-unchecked float? (x) (-> (seq x) bool))
X;(declare-unchecked flush-input () (-> (seq) bool))
X;(declare-unchecked flush-output () (-> (seq) bool))
X;(declare-unchecked implode () (-> (seq (list literal)) literal))
X;(declare-unchecked line-length () (-> (seq) int))
X;(declare-unchecked macro? (x) (-> (seq x) bool))
X;(declare-unchecked mapcar (x y) (-> (seq (-> (seq x) y) (list x)) (list y)))
X;(declare-unchecked port? (x) (-> (seq x) bool))
X;(declare-unchecked print& (x) (-> (seq x) bool))
X;(declare-unchecked read-atom () (-> (seq) literal))
X;(declare-unchecked set-line-length! () (-> (seq int) int))
X;(declare-unchecked symbol->ascii () (-> (seq literal) int))
X;(declare-unchecked thaw (x) (-> (seq (-> (seq) x)) x))
X;(declare-unchecked writeln (x) (-> (seq . x) bool))
X;; maybe this works for Chez;
X
X;;; ****************************************************************
X
X;;; standard type constructors
X
X(define-record-type (triv)
X  (make-triv ()))
X
X(define-checked triv triv (make-triv))
X
X;;; which of these shall we use??  I vote for the first (replacing
X;;; casefn by union-case.
X
X(define-record-type (union x y)
X   (inL (x))
X   (inR (y)))
X
X'(define-type-constructor (union x y)
X  (pair literal (pair x y))
X  (inL
X    (generic (x y)
X      (-> (seq x) (union x y)))
X    (lambda (v)
X      (enc (pair 'L (pair v any)))))
X  (inR
X    (generic (x y)
X      (-> (seq y) (union x y)))
X    (lambda (v)
X      (enc (pair 'R (pair any v)))))
X  (casefn
X    (generic (x y z)
X      (-> (seq (union x y)
X	       (-> (seq x) z)
X	       (-> (seq y) z))
X	  z))
X    (lambda (l f g)
X      ((lambda (q)
X	 (if (eq? q 'L)
X	   (f (lson (rson (dec l))))
X	   (if (eq? q 'R)
X	     (g (rson (rson (dec l))))
X	     (reset))))
X       (lson (dec l))))))
X
X
X;;; ****************************************************************
X
X; This declaration of apply is useless and should be ignored.  It is present
X; for historical reasons only.
X
X'(declare-unchecked 
X   apply (x y) 
X   (->
X      (seq
X	 (-> (seq . x) y)
X	 (seq . x))
X      y))
X
X;;; ****************************************************************
X
X(define-type-constructor (alist x)
X  (list (pair literal x))
X  (alist$ext
X    (generic (x)
X      (-> (seq (alist x) literal x)
X	  (alist x)))
X    (lambda (l id val)
X      (enc (cons (pair id val) (dec l)))))
X  (alist$bvars
X    (generic (x) 
X      (-> (seq (alist x)) (list literal)))
X    (lambda (l) (map lson (dec l))))
X  (alist$init
X    (generic (x)
X      (alist x))
X    (enc nil)))
X
X
SHAR_EOF
if test 8797 -ne "`wc -c globals.s`"
then
echo shar: error transmitting globals.s '(should have been 8797 characters)'
fi
#	End of shell archive
exit 0
